
/*
 * public xen defines and struct for arm64
 * generated by mkheader.py -- DO NOT EDIT
 */

#ifndef __FOREIGN_ARM64_H__
#define __FOREIGN_ARM64_H__ 1


#define __aarch64___ARM64 1
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
# define __DECL_REG(n64, n32) union { __align8__ uint64_t n64; uint32_t n32; }
# define __align8__ __attribute__((aligned (8)))
#else
# define __DECL_REG(n64, n32) __align8__ uint64_t n64
# define __align8__ FIXME
#endif

#define XEN_LEGACY_MAX_VCPUS_ARM64 1
#define _VGCF_online_ARM64                   0
#define VGCF_online_ARM64                    (1<<_VGCF_online_ARM64)

#define arm64_has_no_vcpu_cr_regs 1

#define arm64_has_no_vcpu_ar_regs 1

#define arm64_has_no_start_info 1

#define arm64_has_no_trap_info 1

#define arm64_has_no_cpu_user_regs 1

struct vcpu_guest_core_regs_arm64 {
    __DECL_REG(x0,           r0_usr);
    __DECL_REG(x1,           r1_usr);
    __DECL_REG(x2,           r2_usr);
    __DECL_REG(x3,           r3_usr);
    __DECL_REG(x4,           r4_usr);
    __DECL_REG(x5,           r5_usr);
    __DECL_REG(x6,           r6_usr);
    __DECL_REG(x7,           r7_usr);
    __DECL_REG(x8,           r8_usr);
    __DECL_REG(x9,           r9_usr);
    __DECL_REG(x10,          r10_usr);
    __DECL_REG(x11,          r11_usr);
    __DECL_REG(x12,          r12_usr);
    __DECL_REG(x13,          sp_usr);
    __DECL_REG(x14,          lr_usr);
    __DECL_REG(x15,          __unused_sp_hyp);
    __DECL_REG(x16,          lr_irq);
    __DECL_REG(x17,          sp_irq);
    __DECL_REG(x18,          lr_svc);
    __DECL_REG(x19,          sp_svc);
    __DECL_REG(x20,          lr_abt);
    __DECL_REG(x21,          sp_abt);
    __DECL_REG(x22,          lr_und);
    __DECL_REG(x23,          sp_und);
    __DECL_REG(x24,          r8_fiq);
    __DECL_REG(x25,          r9_fiq);
    __DECL_REG(x26,          r10_fiq);
    __DECL_REG(x27,          r11_fiq);
    __DECL_REG(x28,          r12_fiq);
    __DECL_REG(x29,          sp_fiq);
    __DECL_REG(x30,          lr_fiq);
    __DECL_REG(pc64,         pc32);             
    uint32_t cpsr;                              
    union {
        uint32_t spsr_el1;       
        uint32_t spsr_svc;       
    };
    uint32_t spsr_fiq, spsr_irq, spsr_und, spsr_abt;
    __align8__ uint64_t sp_el0;
    __align8__ uint64_t sp_el1, elr_el1;
};
typedef struct vcpu_guest_core_regs_arm64 vcpu_guest_core_regs_arm64_t;

struct vcpu_guest_context_arm64 {
    uint32_t flags;                         
    struct vcpu_guest_core_regs_arm64 user_regs;  
    uint32_t sctlr, ttbcr;
    __align8__ uint64_t ttbr0, ttbr1;
};
typedef struct vcpu_guest_context_arm64 vcpu_guest_context_arm64_t;

#define arm64_has_no_arch_vcpu_info 1

#define arm64_has_no_vcpu_time_info 1

#define arm64_has_no_vcpu_info 1

#define arm64_has_no_arch_shared_info 1

#define arm64_has_no_shared_info 1


#undef __DECL_REG

#endif /* __FOREIGN_ARM64_H__ */
